package turbowin;

import java.net.URL;
import javax.swing.ImageIcon;
import javax.swing.JOptionPane;
import javax.swing.SwingWorker;
/*
 * myCM.java
 *
 * Created on 6 april 2007, 7:39
 */

/**
 *
 * @author  stam
 */
final public class mycm extends javax.swing.JFrame 
{
   
   /** Creates new form myCM */
   public mycm() 
   {
      initComponents();
      initComponents2();
      initSynopparameters(); 
      setLocation(main.x_pos_frame, main.y_pos_frame);
      initImages();
     
   }
   

   
   /** This method is called from within the constructor to
    * initialize the form.
    * WARNING: Do NOT modify this code. The content of this method is
    * always regenerated by the Form Editor.
    */
   // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
   private void initComponents() {

      buttonGroup1 = new javax.swing.ButtonGroup();
      jLabel1 = new javax.swing.JLabel();
      jLabel2 = new javax.swing.JLabel();
      jLabel3 = new javax.swing.JLabel();
      jLabel4 = new javax.swing.JLabel();
      jLabel5 = new javax.swing.JLabel();
      jLabel6 = new javax.swing.JLabel();
      jLabel7 = new javax.swing.JLabel();
      jLabel8 = new javax.swing.JLabel();
      jLabel9 = new javax.swing.JLabel();
      jButton1 = new javax.swing.JButton();
      jButton2 = new javax.swing.JButton();
      jButton3 = new javax.swing.JButton();
      jRadioButton1 = new javax.swing.JRadioButton();
      jRadioButton2 = new javax.swing.JRadioButton();
      jRadioButton3 = new javax.swing.JRadioButton();
      jRadioButton4 = new javax.swing.JRadioButton();
      jRadioButton5 = new javax.swing.JRadioButton();
      jRadioButton6 = new javax.swing.JRadioButton();
      jRadioButton7 = new javax.swing.JRadioButton();
      jRadioButton8 = new javax.swing.JRadioButton();
      jRadioButton9 = new javax.swing.JRadioButton();
      jRadioButton10 = new javax.swing.JRadioButton();
      jRadioButton11 = new javax.swing.JRadioButton();
      jSeparator1 = new javax.swing.JSeparator();
      jLabel10 = new javax.swing.JLabel();
      jLabel11 = new javax.swing.JLabel();
      jRadioButton12 = new javax.swing.JRadioButton();
      jRadioButton13 = new javax.swing.JRadioButton();
      jLabel12 = new javax.swing.JLabel();
      jButton4 = new javax.swing.JButton();
      jButton5 = new javax.swing.JButton();

      setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
      setTitle("Clouds middle");
      setMinimumSize(new java.awt.Dimension(800, 600));
      setResizable(false);

      jLabel1.setText("image Cm1");
      jLabel1.setDoubleBuffered(true);
      jLabel1.addMouseListener(new java.awt.event.MouseAdapter() {
         public void mouseClicked(java.awt.event.MouseEvent evt) {
            cm1_image_mouseClicked(evt);
         }
      });

      jLabel2.setText("image Cm2");
      jLabel2.setDoubleBuffered(true);
      jLabel2.addMouseListener(new java.awt.event.MouseAdapter() {
         public void mouseClicked(java.awt.event.MouseEvent evt) {
            cm2_image_mouseClicked(evt);
         }
      });

      jLabel3.setText("image Cm3");
      jLabel3.setDoubleBuffered(true);
      jLabel3.addMouseListener(new java.awt.event.MouseAdapter() {
         public void mouseClicked(java.awt.event.MouseEvent evt) {
            cm3_image_mouseClicked(evt);
         }
      });

      jLabel4.setText("image Cm4");
      jLabel4.setDoubleBuffered(true);
      jLabel4.addMouseListener(new java.awt.event.MouseAdapter() {
         public void mouseClicked(java.awt.event.MouseEvent evt) {
            cm4_image_mouseClicked(evt);
         }
      });

      jLabel5.setText("image Cm5");
      jLabel5.setDoubleBuffered(true);
      jLabel5.addMouseListener(new java.awt.event.MouseAdapter() {
         public void mouseClicked(java.awt.event.MouseEvent evt) {
            cm5_image_mouseClicked(evt);
         }
      });

      jLabel6.setText("image Cm6");
      jLabel6.setDoubleBuffered(true);
      jLabel6.addMouseListener(new java.awt.event.MouseAdapter() {
         public void mouseClicked(java.awt.event.MouseEvent evt) {
            cm6_image_mouseClicked(evt);
         }
      });

      jLabel7.setText("image Cm7a");
      jLabel7.setDoubleBuffered(true);
      jLabel7.addMouseListener(new java.awt.event.MouseAdapter() {
         public void mouseClicked(java.awt.event.MouseEvent evt) {
            cm7a_image_mouseClicked(evt);
         }
      });

      jLabel8.setText("image Cm8");
      jLabel8.setDoubleBuffered(true);
      jLabel8.addMouseListener(new java.awt.event.MouseAdapter() {
         public void mouseClicked(java.awt.event.MouseEvent evt) {
            cm8_image_mouseClicked(evt);
         }
      });

      jLabel9.setText("image Cm9");
      jLabel9.setDoubleBuffered(true);
      jLabel9.addMouseListener(new java.awt.event.MouseAdapter() {
         public void mouseClicked(java.awt.event.MouseEvent evt) {
            cm9_image_mouseClicked(evt);
         }
      });

      jButton1.setText("OK");
      jButton1.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
            OK_button_actionPerformed(evt);
         }
      });

      jButton2.setText("Cancel");
      jButton2.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
            Cancel_button_actionPerformed(evt);
         }
      });

      jButton3.setText("Internet");
      jButton3.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
            Internet_button_actionPerformed(evt);
         }
      });

      buttonGroup1.add(jRadioButton1);
      jRadioButton1.setText("Cm1");
      jRadioButton1.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
      jRadioButton1.setMargin(new java.awt.Insets(0, 0, 0, 0));

      buttonGroup1.add(jRadioButton2);
      jRadioButton2.setText("Cm2");
      jRadioButton2.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
      jRadioButton2.setMargin(new java.awt.Insets(0, 0, 0, 0));

      buttonGroup1.add(jRadioButton3);
      jRadioButton3.setText("Cm3");
      jRadioButton3.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
      jRadioButton3.setMargin(new java.awt.Insets(0, 0, 0, 0));

      buttonGroup1.add(jRadioButton4);
      jRadioButton4.setText("Cm4");
      jRadioButton4.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
      jRadioButton4.setMargin(new java.awt.Insets(0, 0, 0, 0));

      buttonGroup1.add(jRadioButton5);
      jRadioButton5.setText("Cm5");
      jRadioButton5.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
      jRadioButton5.setMargin(new java.awt.Insets(0, 0, 0, 0));

      buttonGroup1.add(jRadioButton6);
      jRadioButton6.setText("Cm6");
      jRadioButton6.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
      jRadioButton6.setMargin(new java.awt.Insets(0, 0, 0, 0));

      buttonGroup1.add(jRadioButton7);
      jRadioButton7.setText("Cm7");
      jRadioButton7.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
      jRadioButton7.setMargin(new java.awt.Insets(0, 0, 0, 0));

      buttonGroup1.add(jRadioButton8);
      jRadioButton8.setText("Cm8");
      jRadioButton8.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
      jRadioButton8.setMargin(new java.awt.Insets(0, 0, 0, 0));

      buttonGroup1.add(jRadioButton9);
      jRadioButton9.setText("Cm9");
      jRadioButton9.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
      jRadioButton9.setMargin(new java.awt.Insets(0, 0, 0, 0));

      buttonGroup1.add(jRadioButton10);
      jRadioButton10.setText("no clouds Cm");
      jRadioButton10.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
      jRadioButton10.setMargin(new java.awt.Insets(0, 0, 0, 0));

      buttonGroup1.add(jRadioButton11);
      jRadioButton11.setText("not determined");
      jRadioButton11.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
      jRadioButton11.setMargin(new java.awt.Insets(0, 0, 0, 0));

      jLabel10.setText("image Cm7b");
      jLabel10.setDoubleBuffered(true);
      jLabel10.addMouseListener(new java.awt.event.MouseAdapter() {
         public void mouseClicked(java.awt.event.MouseEvent evt) {
            cm7b_image_mouseClicked(evt);
         }
      });

      jLabel11.setText("image Cm7c");
      jLabel11.setDoubleBuffered(true);
      jLabel11.addMouseListener(new java.awt.event.MouseAdapter() {
         public void mouseClicked(java.awt.event.MouseEvent evt) {
            cm7c_image_mouseClicked(evt);
         }
      });

      buttonGroup1.add(jRadioButton12);
      jRadioButton12.setText("Cm7");
      jRadioButton12.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
      jRadioButton12.setMargin(new java.awt.Insets(0, 0, 0, 0));

      buttonGroup1.add(jRadioButton13);
      jRadioButton13.setText("Cm7");
      jRadioButton13.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
      jRadioButton13.setMargin(new java.awt.Insets(0, 0, 0, 0));
      jRadioButton13.setMaximumSize(new java.awt.Dimension(39, 19));
      jRadioButton13.setMinimumSize(new java.awt.Dimension(39, 19));
      jRadioButton13.setPreferredSize(new java.awt.Dimension(39, 19));

      jLabel12.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
      jLabel12.setText("--- click on the appropriate thumbnail for more internet photos ---");

      jButton4.setText("Back");
      jButton4.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
            Back_button_actionPerformed(evt);
         }
      });

      jButton5.setText("Stop");
      jButton5.addActionListener(new java.awt.event.ActionListener() {
         public void actionPerformed(java.awt.event.ActionEvent evt) {
            Stop_button_actionPerformed(evt);
         }
      });

      javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
      getContentPane().setLayout(layout);
      layout.setHorizontalGroup(
         layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(layout.createSequentialGroup()
            .addGap(74, 74, 74)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
               .addGroup(layout.createSequentialGroup()
                  .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                     .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)
                     .addComponent(jRadioButton4)
                     .addComponent(jLabel10, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)
                     .addComponent(jRadioButton12, javax.swing.GroupLayout.PREFERRED_SIZE, 49, javax.swing.GroupLayout.PREFERRED_SIZE))
                  .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                  .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                     .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                           .addComponent(jRadioButton1)
                           .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                           .addComponent(jRadioButton2)
                           .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)))
                     .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                           .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)
                           .addComponent(jRadioButton5)
                           .addComponent(jLabel11, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)
                           .addComponent(jRadioButton13, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                           .addComponent(jRadioButton6)
                           .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)
                           .addComponent(jLabel8, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)
                           .addComponent(jRadioButton8)))))
               .addComponent(jRadioButton10))
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
               .addComponent(jRadioButton3)
               .addComponent(jRadioButton7)
               .addComponent(jRadioButton9)
               .addComponent(jRadioButton11)
               .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jLabel9, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 150, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
         .addGroup(layout.createSequentialGroup()
            .addContainerGap()
            .addComponent(jSeparator1)
            .addContainerGap())
         .addGroup(layout.createSequentialGroup()
            .addContainerGap()
            .addComponent(jLabel12, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addContainerGap())
         .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
            .addGap(160, 160, 160)
            .addComponent(jButton4, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(18, 18, 18)
            .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(18, 18, 18)
            .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(18, 18, 18)
            .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(18, 18, 18)
            .addComponent(jButton5, javax.swing.GroupLayout.PREFERRED_SIZE, 80, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addContainerGap(158, Short.MAX_VALUE))
      );
      layout.setVerticalGroup(
         layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
         .addGroup(layout.createSequentialGroup()
            .addContainerGap()
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
               .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
               .addComponent(jRadioButton1)
               .addComponent(jRadioButton2)
               .addComponent(jRadioButton3))
            .addGap(19, 19, 19)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE, false)
               .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jLabel5, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
               .addGroup(layout.createSequentialGroup()
                  .addGap(51, 51, 51)
                  .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                     .addComponent(jLabel10, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
                     .addComponent(jLabel8, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
                     .addComponent(jLabel11, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
                     .addComponent(jLabel9, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE))
                  .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                  .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                     .addComponent(jRadioButton8)
                     .addComponent(jRadioButton9)
                     .addComponent(jRadioButton12)
                     .addComponent(jRadioButton13, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                  .addGap(31, 31, 31)
                  .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                     .addComponent(jRadioButton10)
                     .addComponent(jRadioButton11)))
               .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                  .addComponent(jRadioButton4)
                  .addComponent(jRadioButton5)
                  .addComponent(jRadioButton6)
                  .addComponent(jRadioButton7)))
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 30, Short.MAX_VALUE)
            .addComponent(jLabel12)
            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
            .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
            .addGap(15, 15, 15)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
               .addComponent(jButton4, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jButton3, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
               .addComponent(jButton5, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addGap(15, 15, 15))
      );

      pack();
   }// </editor-fold>//GEN-END:initComponents



   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void initComponents2()
   {
      // hide Back/Stop buttons if not in next_screen_mode
      if (main.in_next_sequence == false)
      {
         jButton4.setEnabled(false);                         // back button
         jButton5.setEnabled(false);                         // stop button
      }


      if (main.offline_mode == true)
      {
         jButton3.setText("Help");
         jLabel12.setText("--- click on the appropriate thumbnail for more cloud photos ---");
      }
   }




   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   public ImageIcon createImageIcon(String path_and_file)
   {
      URL url = null;

      try
      {
         url = getClass().getResource(path_and_file);
      }
      catch (Exception e) { /* ... */}

      ImageIcon icon_glyph = new javax.swing.ImageIcon(url);

      return icon_glyph;
   }
  
   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void initImages()
   {
      main.OSType ostype = main.detect_OS();
      String os = "";
      switch (ostype)
      {
         case WINDOWS: os = "WINDOWS"; 
                       break;
         case MACOS:   os = "MACOS"; 
                       break;
         case LINUX:   os = "LINUX"; 
                       break;
         case OTHER:   os = "OTHER"; 
                       break;
         default:      os = "OTHER"; 
                       break;
      }    
      
      if (os.equals("LINUX"))
      {   
         // NB
         //    on Fedora linux approx. every 5-10 times when activating the form the glyphs are not loaded (no errors or exceptions)
         //    even with using BufferdImages instead of the imageIcons, the same result. 
         //    After testing all the pictures were found everytime (so that was not the issue)
         //    It seems the background loading is not always ok on Fedora         
         
         loadImage_straight(main.ICONS_DIRECTORY + "glyph_cm_1.jpg");
         loadImage_straight(main.ICONS_DIRECTORY + "glyph_cm_2.jpg");
         loadImage_straight(main.ICONS_DIRECTORY + "glyph_cm_3.jpg");
         loadImage_straight(main.ICONS_DIRECTORY + "glyph_cm_4.jpg");
         loadImage_straight(main.ICONS_DIRECTORY + "glyph_cm_5.jpg");
         loadImage_straight(main.ICONS_DIRECTORY + "glyph_cm_6.jpg");
         loadImage_straight(main.ICONS_DIRECTORY + "glyph_cm_7a.jpg");
         loadImage_straight(main.ICONS_DIRECTORY + "glyph_cm_7b.jpg");
         loadImage_straight(main.ICONS_DIRECTORY + "glyph_cm_7c.jpg");
         loadImage_straight(main.ICONS_DIRECTORY + "glyph_cm_8.jpg");
         loadImage_straight(main.ICONS_DIRECTORY + "glyph_cm_9.jpg");
      }
      else
      {   
         loadImage(main.ICONS_DIRECTORY + "glyph_cm_1.jpg");
         loadImage(main.ICONS_DIRECTORY + "glyph_cm_2.jpg");
         loadImage(main.ICONS_DIRECTORY + "glyph_cm_3.jpg");
         loadImage(main.ICONS_DIRECTORY + "glyph_cm_4.jpg");
         loadImage(main.ICONS_DIRECTORY + "glyph_cm_5.jpg");
         loadImage(main.ICONS_DIRECTORY + "glyph_cm_6.jpg");
         loadImage(main.ICONS_DIRECTORY + "glyph_cm_7a.jpg");
         loadImage(main.ICONS_DIRECTORY + "glyph_cm_7b.jpg");
         loadImage(main.ICONS_DIRECTORY + "glyph_cm_7c.jpg");
         loadImage(main.ICONS_DIRECTORY + "glyph_cm_8.jpg");
         loadImage(main.ICONS_DIRECTORY + "glyph_cm_9.jpg");
      }
   } // protected void initImages()   


   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   // The doInBackground method, which creates the image icon for the photograph, is invoked by the background thread. 
   // After the image icon is fully loaded, the done method is invoked on the event-dispatching thread. 
   // This updates the GUI to display the photograph
   
   // SwingWorker is only designed to be executed once. Executing a SwingWorker more than once will not result in invoking the doInBackground method twice.
   // see: http://java.sun.com/javase/6/docs/api/javax/swing/SwingWorker.html
   private void loadImage(final String imagePath) 
   {
      new SwingWorker<ImageIcon, Object>() 
      {
         @Override
         public ImageIcon doInBackground() 
         {
             return createImageIcon(imagePath);
         }

            @Override
         public void done()
         {
            try
            {        
               if (imagePath.equals(main.ICONS_DIRECTORY + "glyph_cm_1.jpg"))
               {
                  ImageIcon img_cm1= get();
                  jLabel1.setIcon(img_cm1); 
               }   
               else if (imagePath.equals(main.ICONS_DIRECTORY + "glyph_cm_2.jpg"))
               {    
                  ImageIcon img_cm2= get();
                  jLabel2.setIcon(img_cm2); 
               }   
               else if (imagePath.equals(main.ICONS_DIRECTORY + "glyph_cm_3.jpg"))
               {    
                  ImageIcon img_cm3= get();
                  jLabel3.setIcon(img_cm3); 
               }   
               else if (imagePath.equals(main.ICONS_DIRECTORY + "glyph_cm_4.jpg"))
               {
                  ImageIcon img_cm4= get();
                  jLabel4.setIcon(img_cm4); 
               }   
               else if (imagePath.equals(main.ICONS_DIRECTORY + "glyph_cm_5.jpg"))
               {    
                  ImageIcon img_cm5= get();
                  jLabel5.setIcon(img_cm5); 
               }   
               else if (imagePath.equals(main.ICONS_DIRECTORY + "glyph_cm_6.jpg"))
               {    
                  ImageIcon img_cm6= get();
                  jLabel6.setIcon(img_cm6); 
               }   
               else if (imagePath.equals(main.ICONS_DIRECTORY + "glyph_cm_7a.jpg"))
               {
                  ImageIcon img_cm7a= get();
                  jLabel7.setIcon(img_cm7a); 
               }   
               else if (imagePath.equals(main.ICONS_DIRECTORY + "glyph_cm_7b.jpg"))
               {
                  ImageIcon img_cm7b= get();
                  jLabel10.setIcon(img_cm7b); 
               }   
               else if (imagePath.equals(main.ICONS_DIRECTORY + "glyph_cm_7c.jpg"))
               {
                  ImageIcon img_cm7c= get();
                  jLabel11.setIcon(img_cm7c); 
               }   
               else if (imagePath.equals(main.ICONS_DIRECTORY + "glyph_cm_8.jpg"))
               {    
                  ImageIcon img_cm8= get();
                  jLabel8.setIcon(img_cm8); 
               }   
               else if (imagePath.equals(main.ICONS_DIRECTORY + "glyph_cm_9.jpg"))
               {    
                  ImageIcon img_cm9= get();
                  jLabel9.setIcon(img_cm9); 
               }   
                
            } // try
            catch (InterruptedException ignore) { }
            catch (java.util.concurrent.ExecutionException e) 
            {
                String why = null;
                Throwable cause = e.getCause();
                if (cause != null) 
                {
                   why = cause.getMessage();
                } 
                else 
                {
                   why = e.getMessage();
                }
                //System.err.println("Error retrieving file: " + why);
                JOptionPane.showMessageDialog(null, "Error retrieving file: " + why,  main.APPLICATION_NAME + " error", JOptionPane.ERROR_MESSAGE);
            } // catch         
         } //  public void done()
      }.execute();
   } // private void loadImage(final String imagePath, final int index)

   

   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void loadImage_straight(final String imagePath) 
   {
      if (imagePath.equals(main.ICONS_DIRECTORY + "glyph_cm_1.jpg"))
      {
         ImageIcon img_cm1= createImageIcon(imagePath);
         jLabel1.setIcon(img_cm1); 
      }   
      else if (imagePath.equals(main.ICONS_DIRECTORY + "glyph_cm_2.jpg"))
      {    
         ImageIcon img_cm2= createImageIcon(imagePath);
         jLabel2.setIcon(img_cm2); 
      }   
      else if (imagePath.equals(main.ICONS_DIRECTORY + "glyph_cm_3.jpg"))
      {    
         ImageIcon img_cm3= createImageIcon(imagePath);
         jLabel3.setIcon(img_cm3); 
      }   
      else if (imagePath.equals(main.ICONS_DIRECTORY + "glyph_cm_4.jpg"))
      {
         ImageIcon img_cm4= createImageIcon(imagePath);
         jLabel4.setIcon(img_cm4); 
      }   
      else if (imagePath.equals(main.ICONS_DIRECTORY + "glyph_cm_5.jpg"))
      {    
         ImageIcon img_cm5= createImageIcon(imagePath);
         jLabel5.setIcon(img_cm5); 
      }   
      else if (imagePath.equals(main.ICONS_DIRECTORY + "glyph_cm_6.jpg"))
      {    
         ImageIcon img_cm6= createImageIcon(imagePath);
         jLabel6.setIcon(img_cm6); 
      }   
      else if (imagePath.equals(main.ICONS_DIRECTORY + "glyph_cm_7a.jpg"))
      {
         ImageIcon img_cm7a= createImageIcon(imagePath);
         jLabel7.setIcon(img_cm7a); 
      }   
      else if (imagePath.equals(main.ICONS_DIRECTORY + "glyph_cm_7b.jpg"))
      {
         ImageIcon img_cm7b= createImageIcon(imagePath);
         jLabel10.setIcon(img_cm7b); 
      }   
      else if (imagePath.equals(main.ICONS_DIRECTORY + "glyph_cm_7c.jpg"))
      {
         ImageIcon img_cm7c= createImageIcon(imagePath);
         jLabel11.setIcon(img_cm7c); 
      }   
      else if (imagePath.equals(main.ICONS_DIRECTORY + "glyph_cm_8.jpg"))
      {    
         ImageIcon img_cm8= createImageIcon(imagePath);
         jLabel8.setIcon(img_cm8); 
      }   
      else if (imagePath.equals(main.ICONS_DIRECTORY + "glyph_cm_9.jpg"))
      {    
         ImageIcon img_cm9= createImageIcon(imagePath);
         jLabel9.setIcon(img_cm9); 
      }   
   } // private void loadImage(final String imagePath, final int index)



   
   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void initSynopparameters() 
   {


      if (cm_code.compareTo("") != 0)
      {
         if (cm_code.equals(CM1))
            jRadioButton1.setSelected(true);
         else if (cm_code.equals(CM2))
            jRadioButton2.setSelected(true);
         else if (cm_code.equals(CM3))
            jRadioButton3.setSelected(true);
         else if (cm_code.equals(CM4))
            jRadioButton4.setSelected(true);
         else if (cm_code.equals(CM5))
            jRadioButton5.setSelected(true);
         else if (cm_code.equals(CM6))
            jRadioButton6.setSelected(true);
         else if (cm_code.equals(CM7A))
            jRadioButton7.setSelected(true);
         else if (cm_code.equals(CM7B))
            jRadioButton12.setSelected(true);
          else if (cm_code.equals(CM7C))
            jRadioButton13.setSelected(true);
         else if (cm_code.equals(CM8))
            jRadioButton8.setSelected(true);
         else if (cm_code.equals(CM9))
            jRadioButton9.setSelected(true);
         else if (cm_code.equals(CM0))                                // no clouds Cm
            jRadioButton10.setSelected(true);
            
      } // if (cm.compareTo("") != 0)
      else
         jRadioButton11.setSelected(true);                      // not determined   
         
   } // private void initSynopparameters() 


   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void Internet_button_actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Internet_button_actionPerformed
// TODO add your handling code here:
      main.help_mouseClicked(CM_HELP_DIR);
   }//GEN-LAST:event_Internet_button_actionPerformed


   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void Cancel_button_actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Cancel_button_actionPerformed
// TODO add your handling code here:
      setVisible(false);
      dispose();

      /* next screen in in next sequence mode */
      if (main.in_next_sequence == true)
      {
         next_screen();
      }
   }//GEN-LAST:event_Cancel_button_actionPerformed


   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void OK_button_actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OK_button_actionPerformed
// TODO add your handling code here:
      
      if (jRadioButton1.isSelected() == true)
         cm_code = CM1;
      else if (jRadioButton2.isSelected() == true)
         cm_code = CM2;
      else if (jRadioButton3.isSelected() == true)
         cm_code = CM3;
      else if (jRadioButton4.isSelected() == true)
         cm_code = CM4;
      else if (jRadioButton5.isSelected() == true)
         cm_code = CM5;
      else if (jRadioButton6.isSelected() == true)
         cm_code = CM6;
      else if (jRadioButton7.isSelected() == true)
         cm_code = CM7A;
      else if (jRadioButton12.isSelected() == true)
         cm_code = CM7B;
      else if (jRadioButton13.isSelected() == true)
         cm_code = CM7C;
      else if (jRadioButton8.isSelected() == true)
         cm_code = CM8;
      else if (jRadioButton9.isSelected() == true)
         cm_code = CM9;
      else if (jRadioButton10.isSelected() == true)
         cm_code = CM0;
      else if (jRadioButton11.isSelected() == true)
         cm_code = "";
      else
         cm_code = "";
      
      /* update clouds middle (Cm) fields on main screen progress */
      main.clouds_middle_fields_update();
      
      /* close this input page */
      setVisible(false);
      dispose();

      /* next screen if in_next_screen mode */
      if (main.in_next_sequence == true)
      {
         next_screen();
      }

   }//GEN-LAST:event_OK_button_actionPerformed


   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void cm1_image_mouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_cm1_image_mouseClicked
      // TODO add your handling code here:
      main.help_mouseClicked(CM1_HELP_DIR);
   }//GEN-LAST:event_cm1_image_mouseClicked


   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void cm2_image_mouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_cm2_image_mouseClicked
      // TODO add your handling code here:
      main.help_mouseClicked(CM2_HELP_DIR);
   }//GEN-LAST:event_cm2_image_mouseClicked


   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void cm3_image_mouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_cm3_image_mouseClicked
      // TODO add your handling code here:
      main.help_mouseClicked(CM3_HELP_DIR);
   }//GEN-LAST:event_cm3_image_mouseClicked


   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void cm4_image_mouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_cm4_image_mouseClicked
      // TODO add your handling code here:
      main.help_mouseClicked(CM4_HELP_DIR);
   }//GEN-LAST:event_cm4_image_mouseClicked


   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void cm5_image_mouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_cm5_image_mouseClicked
      // TODO add your handling code here:
      main.help_mouseClicked(CM5_HELP_DIR);
   }//GEN-LAST:event_cm5_image_mouseClicked


   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void cm6_image_mouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_cm6_image_mouseClicked
      // TODO add your handling code here:
      main.help_mouseClicked(CM6_HELP_DIR);
   }//GEN-LAST:event_cm6_image_mouseClicked


   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void cm7a_image_mouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_cm7a_image_mouseClicked
      // TODO add your handling code here:
      main.help_mouseClicked(CM7_HELP_DIR);
   }//GEN-LAST:event_cm7a_image_mouseClicked


   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void cm7b_image_mouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_cm7b_image_mouseClicked
      // TODO add your handling code here:
      main.help_mouseClicked(CM7_HELP_DIR);
   }//GEN-LAST:event_cm7b_image_mouseClicked


   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void cm7c_image_mouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_cm7c_image_mouseClicked
      // TODO add your handling code here:
      main.help_mouseClicked(CM7_HELP_DIR);
   }//GEN-LAST:event_cm7c_image_mouseClicked


   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void cm8_image_mouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_cm8_image_mouseClicked
      // TODO add your handling code here:
      main.help_mouseClicked(CM8_HELP_DIR);
   }//GEN-LAST:event_cm8_image_mouseClicked


   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void cm9_image_mouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_cm9_image_mouseClicked
      // TODO add your handling code here:
      main.help_mouseClicked(CM9_HELP_DIR);
   }//GEN-LAST:event_cm9_image_mouseClicked


   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void Back_button_actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Back_button_actionPerformed
      // TODO add your handling code here:
      setVisible(false);
      dispose();

      previous_screen();
   }//GEN-LAST:event_Back_button_actionPerformed


   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void Stop_button_actionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_Stop_button_actionPerformed
      // TODO add your handling code here:
      setVisible(false);
      dispose();

      main.in_next_sequence = false;
   }//GEN-LAST:event_Stop_button_actionPerformed


   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void previous_screen()
   {
      mycl form = new mycl();
      form.setSize(800, 600);
      form.setVisible(true);
   }


   /***********************************************************************************************/
   /*                                                                                             */
   /*                                                                                             */
   /*                                                                                             */
   /***********************************************************************************************/
   private void next_screen()
   {
      mych form = new mych();
      form.setSize(800, 600);
      form.setVisible(true);
   }


   /**
    * @param args the command line arguments
    */
   public static void main(String args[]) {
      java.awt.EventQueue.invokeLater(new Runnable() {
         @Override
         public void run() {
            new mycm().setVisible(true);
         }
      });
   }
   
   // Variables declaration - do not modify//GEN-BEGIN:variables
   private javax.swing.ButtonGroup buttonGroup1;
   private javax.swing.JButton jButton1;
   private javax.swing.JButton jButton2;
   private javax.swing.JButton jButton3;
   private javax.swing.JButton jButton4;
   private javax.swing.JButton jButton5;
   private javax.swing.JLabel jLabel1;
   private javax.swing.JLabel jLabel10;
   private javax.swing.JLabel jLabel11;
   private javax.swing.JLabel jLabel12;
   private javax.swing.JLabel jLabel2;
   private javax.swing.JLabel jLabel3;
   private javax.swing.JLabel jLabel4;
   private javax.swing.JLabel jLabel5;
   private javax.swing.JLabel jLabel6;
   private javax.swing.JLabel jLabel7;
   private javax.swing.JLabel jLabel8;
   private javax.swing.JLabel jLabel9;
   private javax.swing.JRadioButton jRadioButton1;
   private javax.swing.JRadioButton jRadioButton10;
   private javax.swing.JRadioButton jRadioButton11;
   private javax.swing.JRadioButton jRadioButton12;
   private javax.swing.JRadioButton jRadioButton13;
   private javax.swing.JRadioButton jRadioButton2;
   private javax.swing.JRadioButton jRadioButton3;
   private javax.swing.JRadioButton jRadioButton4;
   private javax.swing.JRadioButton jRadioButton5;
   private javax.swing.JRadioButton jRadioButton6;
   private javax.swing.JRadioButton jRadioButton7;
   private javax.swing.JRadioButton jRadioButton8;
   private javax.swing.JRadioButton jRadioButton9;
   private javax.swing.JSeparator jSeparator1;
   // End of variables declaration//GEN-END:variables
 
   public static String cm_code      = "";
   
   // constants
   private final String CM0          = "0";
   private final String CM1          = "1";
   private final String CM2          = "2";
   private final String CM3          = "3";
   private final String CM4          = "4";
   private final String CM5          = "5";
   private final String CM6          = "6";
   private final String CM7A         = "7a";
   private final String CM7B         = "7b";
   private final String CM7C         = "7c";
   private final String CM8          = "8";
   private final String CM9          = "9";
   private final String CM_HELP_DIR  = "cm.pdf";
   private final String CM1_HELP_DIR = "cm_1.pdf";
   private final String CM2_HELP_DIR = "cm_2.pdf";
   private final String CM3_HELP_DIR = "cm_3.pdf";
   private final String CM4_HELP_DIR = "cm_4.pdf";
   private final String CM5_HELP_DIR = "cm_5.pdf";
   private final String CM6_HELP_DIR = "cm_6.pdf";
   private final String CM7_HELP_DIR = "cm_7.pdf";
   private final String CM8_HELP_DIR = "cm_8.pdf";
   private final String CM9_HELP_DIR = "cm_9.pdf";
   
  
} // public class mych extends javax.swing.JFrame 
